unit ExeMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ImgList, Menus;

//-----------------------------------------------------------------------------
//  ԍŏsNX
type
    TExecuteProc = procedure() of object;

    TTimeLagExecuter = class(TThread)
    private
        FTick: Cardinal;
        procedure ExecProc();
    public
        TimeLag: Cardinal;
        ExecuteProc: TExecuteProc;
    protected
        procedure Execute(); override;
        procedure Reserve();
        procedure Cancel();
    public
        constructor Create();
    end;

//-----------------------------------------------------------------------------
//  tH[
type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Timer1: TTimer;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    WndProc: TWndMethod;
    procedure CustomWndProc(var Msg: TMessage);
    procedure HookedMouseProc(const Msg: TMessage);
    procedure HookedShellProc(const Msg: TMessage);
    procedure MessageOut(const AMsg: String);
  private
    FPrevTick: Cardinal;
    FPrevPID: Cardinal;
    FExecuter: TTimeLagExecuter;
    procedure OnDoubleClickDesktop();

  //  p̂߂̏
  private
    procedure InitializeMenu();
    procedure MenuFolderHierarchy(Sender: TObject);
  end;

var
    MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    ExeInfo;

const
    HOOK_DLL_NAME = 'PasteItHook.dll';

//=============================================================================
//  p̂߂̏

//-----------------------------------------------------------------------------
//  p\ȃhCu̗
function GetAvailableDrives(): String;
var
    LDriveNum: Integer;
    LDriveChar: Char;
    LDriveBits: set of 0..25;
begin
    Result := '';
    Integer(LDriveBits) := GetLogicalDrives();
    for LDriveNum := 0 to 25 do
    begin
        if not (LDriveNum in LDriveBits) then Continue;
        LDriveChar := UpCase(Char(LDriveNum + Ord('a')));
        Result := Result + LDriveChar;
    end;
end;

//-----------------------------------------------------------------------------
//  TutH_
function ListSubDir(const APath: String; AList: TStrings): Integer;
var
    LPath: String;
    LSearchRec: TSearchRec;
    LTemp: String;
begin
    AList.Clear();
    LPath := IncludeTrailingPathDelimiter(APath);
    if (0 = FindFirst(LPath + '*.*', faAnyFile, LSearchRec)) then
    begin
        try
            repeat
                //  gƐe͏O
                if ('.' = LSearchRec.Name) or ('..' = LSearchRec.Name) then Continue;
                LTemp := IncludeTrailingPathDelimiter(LPath + LSearchRec.Name);
                if DirectoryExists(LTemp) then AList.Add(LSearchRec.Name);
            until
                0 <> FindNext(LSearchRec);
        finally
            FindClose(LSearchRec);
        end;
    end;
    Result := AList.Count;
end;

//-----------------------------------------------------------------------------
//  tH_Kw\郁j[(܂Ƃ߂ׂ)
procedure TMainForm.InitializeMenu();
const
    CSIDL_DESKTOP = $0000;
    CSIDL_PERSONAL = $0005;
var
    LPath: String;
    LDrives: String;
    i: Integer;
    LMenuItem: TMenuItem;
    LSubItem: TMenuItem;
begin
    //  LZ
    LMenuItem := TMenuItem.Create(PopupMenu1);
    LMenuItem.Caption := 'Cancel';
    PopupMenu1.Items.Add(LMenuItem);

    //  fXNgbv
    LPath := GetSpecialFolderPath(CSIDL_DESKTOP);

    LMenuItem := TMenuItem.Create(PopupMenu1);
    LMenuItem.Caption := 'Desktop';
    LMenuItem.Hint := LPath;
    LMenuItem.OnClick:= MenuFolderHierarchy;
    PopupMenu1.Items.Add(LMenuItem);

    LSubItem := TMenuItem.Create(LMenuItem);
    LSubItem.Caption := '̃tH_\';
    LSubItem.Hint := LPath;
    LSubItem.Tag := 1;
    LSubItem.OnClick:= MenuFolderHierarchy;
    LMenuItem.Add(LSubItem);

    //  }ChLg
    LPath := GetSpecialFolderPath(CSIDL_PERSONAL);

    LMenuItem := TMenuItem.Create(PopupMenu1);
    LMenuItem.Caption := 'MyDocuments';
    LMenuItem.Hint := LPath;
    LMenuItem.OnClick:= MenuFolderHierarchy;
    PopupMenu1.Items.Add(LMenuItem);

    LSubItem := TMenuItem.Create(LMenuItem);
    LSubItem.Caption := '̃tH_\';
    LSubItem.Hint := LPath;
    LSubItem.Tag := 1;
    LSubItem.OnClick:= MenuFolderHierarchy;
    LMenuItem.Add(LSubItem);

    //  hCu
    LDrives := GetAvailableDrives();
    for i := 1 to Length(LDrives) do
    begin
        LMenuItem := TMenuItem.Create(PopupMenu1);
        LMenuItem.Caption := LDrives[i] + ':';
        LMenuItem.Hint := LMenuItem.Caption + '\';
        LMenuItem.ImageIndex := 0;
        LMenuItem.OnClick:= MenuFolderHierarchy;
        PopupMenu1.Items.Add(LMenuItem);

        LSubItem := TMenuItem.Create(LMenuItem);
        LSubItem.Caption := '̃hCu\';
        LSubItem.Hint := LMenuItem.Caption + '\';
        LSubItem.Tag := 1;
        LSubItem.OnClick:= MenuFolderHierarchy;
        LMenuItem.Add(LSubItem);
    end;
end;

//-----------------------------------------------------------------------------
//  |bvAbvj[ɃtH_Kw\
//  Date: Wed, 31 May 2000 10:03:48 +0900
//  Subject: [Delphi:48747] Re: TMenuItem  OnMouseOver   ̂ł
procedure TMainForm.MenuFolderHierarchy(Sender: TObject);
var
    LSubDir: TStrings;
    LMenuItem: TMenuItem;
    i: Integer;
    LNewItem: TMenuItem;
    LSubItem: TMenuItem;
    LRoot: String;
    LPath: String;
    LFull: String;
begin
    LMenuItem := TMenuItem(Sender);

    //  ũtH_Jvj[
    if (LMenuItem.Tag > 0) then
    begin
        SimpleShellExecute(LMenuItem.Hint);
    end

    //  tH_Kw
    else
    begin
        //  TutH_ǉ
        LSubDir := nil;
        try
            //  TutH_
            LSubDir := TStringList.Create();
            LRoot := LMenuItem.Hint;
            ListSubDir(LRoot, LSubDir);

            //  ũtH_JvcĎcĂ
            while (LMenuItem.Count > 1) do LMenuItem.Delete(1);

            //  TutH_ǉ
            for i := 0 to LSubDir.Count - 1 do
            begin
                LPath := LSubDir.Strings[i];
                LFull := IncludeTrailingPathDelimiter(LRoot + '\' + LPath);
                LNewItem := TMenuItem.Create(LMenuItem);
                LNewItem.Caption := LPath;
                LNewItem.Hint := LFull;
                LNewItem.OnClick := LMenuItem.OnClick;
                LNewItem.ImageIndex := 1;
                LMenuItem.Add(LNewItem);

                //  ũtH_Jvj[ǉ
                LSubItem := TMenuItem.Create(LNewItem);
                LSubItem.Caption := '̃tH_\';
                LSubItem.Hint := LFull;
                LSubItem.Tag := 1;
                LSubItem.OnClick := LNewItem.OnClick;
                //LSubItem.ImageIndex := 2;
                LNewItem.Add(LSubItem);
            end;
        finally
            LSubDir.Free();
        end;
    end;
end;

//=============================================================================
//  UTILITY

//-----------------------------------------------------------------------------
//  DLLC|[gEăX^eBbNN
function HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure  HookUnInstall(); stdcall;external HOOK_DLL_NAME;

//-----------------------------------------------------------------------------
//  NX擾
//  Win32 API by Object Pascal of Delphi
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetClassNameStr(const hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;

//-----------------------------------------------------------------------------
//  EBhE̍ŏĩEBhE擾
//  Win32 API by Object Pascal of Delphi
function GetMostTopLevelWindow(const hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

//-----------------------------------------------------------------------------
//  J[\nh擾
function GetCursorHandle(): HCURSOR;
var
    LCursorInfo: TCursorInfo;
begin
    FillChar(LCursorInfo, SizeOf(LCursorInfo), 0);
    LCursorInfo.cbSize := SizeOf(LCursorInfo);
    GetCursorInfo(LCursorInfo);
    Result := LCursorInfo.hCursor;
end;

//=============================================================================
//  ԍŏsNX

//-----------------------------------------------------------------------------
//  RXgN^
constructor TTimeLagExecuter.Create();
begin
    inherited Create(True);

    //  ҂ԏl
    TimeLag := 500;
    FTick := 0;

    //  s֐
    ExecuteProc := nil;
end;

//-----------------------------------------------------------------------------
//  s
procedure TTimeLagExecuter.ExecProc();
begin
    if Assigned(ExecuteProc) then
    begin
        ExecuteProc();
    end;
end;

//-----------------------------------------------------------------------------
//  \
procedure TTimeLagExecuter.Reserve();
begin
    FTick := GetTickCount();
end;

//-----------------------------------------------------------------------------
//  LZ
procedure TTimeLagExecuter.Cancel();
begin
    FTick := 0;
end;

//-----------------------------------------------------------------------------
//  C[v
procedure TTimeLagExecuter.Execute();
var
    LPrevCursor: HCURSOR;
    LCurrCursor: HCURSOR;
begin
    inherited;

    LPrevCursor := GetCursorHandle();

    while not Terminated do
    begin
        Sleep(1);

        //  J[\ύXꂽL킳LZ
        LCurrCursor := GetCursorHandle();
        if (LPrevCursor <> LCurrCursor) then
        begin
            Cancel();
            LPrevCursor := LCurrCursor;
        end;

        if (FTick > 0) and (GetTickCount() - FTick > TimeLag) then
        begin
            //  s
            Synchronize(ExecProc);
            Cancel();
        end;
    end;
end;

//=============================================================================
//  tH[

//-----------------------------------------------------------------------------
//  bZ[W\
procedure TMainForm.MessageOut(const AMsg: String);
var
    NowStr: string;
begin
    NowStr := FormatDateTime('yyyy/mm/dd hh:nn:ss:zzz', Now);
    Memo1.Lines.Add(NowStr + ' ' + AMsg);
end;

//-----------------------------------------------------------------------------
//  tH[RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    InitializeMenu();

    FPrevTick := 0;
    FPrevPID := 0;

    //  ^COts쐬
    FExecuter := TTimeLagExecuter.Create();
    FExecuter.TimeLag := 500;
    FExecuter.ExecuteProc := OnDoubleClickDesktop;
    FExecuter.Resume();

    //  EBhEvV[WobNAbv
    WndProc := Self.WindowProc;
    //  ւ
    Self.WindowProc := CustomWndProc;
    //  tbNCXg[
    HookInstall(Self.Handle);
end;

//-----------------------------------------------------------------------------
//  tH[fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  Ô߃ACXg[
    HookUnInstall();
    //  Ô߃EBhEvV[W߂
    Self.WindowProc := WndProc;

    //  ^COtsj
    FExecuter.Cancel();
    FExecuter.Terminate();
    FExecuter.Free();
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.Button1Click(Sender: TObject);
begin
    ShowInfoForm();
end;

//-----------------------------------------------------------------------------
//  ւpEBhEvV[W
procedure TMainForm.CustomWndProc(var Msg: TMessage);
begin
    //  DLL Ō߂ }EXtbNp̃bZ[W ID Ɣr
    case Msg.Msg of
        WM_APP + 2: HookedMouseProc(Msg);
        WM_APP + 3: HookedShellProc(Msg);
    end;

    //  낤Ƃ͌ĂԁB
    WndProc(Msg);
end;

//-----------------------------------------------------------------------------
//  HookedMouseProc mF
procedure TMainForm.HookedMouseProc(const Msg: TMessage);
var
    LPoint: TPoint;
    LHandle: HWND;
    LClassName: String;
begin
    //  _Ń}EX̐^ɂEBhE擾
    GetCursorPos(LPoint);
    LHandle := WindowFromPoint(LPoint);
    //  eq֌Ŵڂ
    LHandle := GetMostTopLevelWindow(LHandle);
    //  NX擾
    LClassName := UpperCase(GetClassNameStr(LHandle));
    //  fXNgbv?
    if (LClassName = 'PROGMAN') then
    begin
        case Msg.WParam of
            //WM_MBUTTONDBLCLK: MessageOut('WM_MBUTTONDBLCLK');
            //WM_LBUTTONDBLCLK: MessageOut('WM_LBUTTONDBLCLK');
            WM_MBUTTONDBLCLK,
            WM_LBUTTONDBLCLK:   FExecuter.Reserve();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  HookedShellProc mF
procedure TMainForm.HookedShellProc(const Msg: TMessage);
var
    LProcessID: Cardinal;
    LTick: Cardinal;
begin
    //  쐬EBhẼvZXID́H
    GetWindowThreadProcessId(Msg.WParam, LProcessID);

    //  ̎Ԃ?
    LTick := GetTickCount();

    //  Oł쐬EBhẼvZXIDƔr
    if (LProcessID = FPrevPID) then
    begin
        //  1bȓȂ炨ȂvZXƔF
        if (LTick - FPrevTick < 1000) then
        begin
            //  ԂXV
            FPrevTick := LTick;
            Exit;
        end;
    end;

    //  ԂƃvZXIDL^
    FPrevTick := LTick;
    FPrevPID := LProcessID;

    //  fobOO
    MessageOut(Format('HSHELL_WINDOWCREATED(PID=%d)', [Msg.WParam]));
    FExecuter.Cancel();
end;

//-----------------------------------------------------------------------------
//  fXNgbv_uNbNꂽ
procedure TMainForm.OnDoubleClickDesktop();
begin
    MessageOut('fXNgbv_uNbN܂B');
    PopupMenu1.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;


end.

